/*
   CPFAT_C
*/


#include <stdio.h>
#include <qlhd.h>

char _prog_name[] = "cpfat";
char _copyright[] = " 8/92 DStk";
char _version[]   = " V1.03 ";

void consetup_title();
void (*_consetup)() = consetup_title;

short rflag = 0;

void Usage();



main(argc, argv)

int argc;
char *argv[];
{
    char *buf, *ret;
    int  err, drive;
    long from_pos, to_pos;
    char *a;

   for (argc--, argv++; argc > 0; argc--, argv++)  {
      a = *argv;
      if (a[0] != '-' || a[1] == '\0')
         break;
      while (*++a) {
         switch(*a) {
            case 'r': rflag++;
                      break;
            case 'V': fputs(_prog_name, stderr);
                      fputs(_version, stderr);
                      fputs(_copyright, stderr);
                      fputc('\n', stderr);
                      exit(1);
            default:  usage();
         }
      }
   }
   if (argc) {
      drive = atoi(*argv);
      argc--;
   } else
      drive = 1;
   if (argc)
      usage();

    ret = find_hd(drive);
    if (ret != NULL) {
        fprintf(stderr, "%s: %s\n", _prog_name, ret);
        exit(1);
    }
    buf = malloc(NUM_PDSECTS * SECLEN);
    if (buf == NULL)
        { perror(_prog_name); exit(2); }
    if (rflag) {
        from_pos = log_to_pos(NUM_PDSECTS);
        to_pos = log_to_pos(0);
     } else {
        from_pos = log_to_pos(0);
        to_pos = log_to_pos(NUM_PDSECTS);
    }
    fprintf(stderr, "%sing FAT of drive %d ...\n",
        rflag ? "Restor" : "Sav", drive);
    err = rd_hd_ms(from_pos, NUM_PDSECTS, buf, driver);
    if (err) {
        fprintf(stderr, "%s: Error while reading.\n", _prog_name);
        exit(2);
    }
#if 0
    err = 0;
#else
    err = wr_hd_ms(to_pos, NUM_PDSECTS, buf, driver);
#endif
    if (err) {
          fprintf(stderr, "%s: Error while writing.\n", _prog_name);
          exit(2);
    }
    exit(0);
}



void Usage()
{
    fprintf(stderr, "Usage: cpfat [-rV] [drive]\n");
    exit(1);
}

